SystemOrganization addCategory: #'Moose-MondrianPaintings'!
SystemOrganization addCategory: #'Moose-MondrianPaintings-FameView'!
SystemOrganization addCategory: #'Moose-MondrianPaintings-LayerTable'!
SystemOrganization addCategory: #'Moose-MondrianPaintings-OverviewPyramid'!

!FAMIXClassGroup methodsFor: '*moose-mondrianpaintings' stamp: 'TudorGirba 12/12/2012 00:21'!
viewAnnotationConstellation
	<menuItem: 'Annotation Constellation' category: 'Visualize'>
	| view |
	view := MOViewRenderer new.
	self viewAnnotationConstellationOn: view.
	^ view openWithStatusbar title: 'Annotation Constellation'! !

!FAMIXClassGroup methodsFor: '*moose-mondrianpaintings' stamp: 'TudorGirba 1/22/2013 20:39'!
viewAnnotationConstellationOn: view
	(FAMIXAnnotationTypeGroup withAll: (self flatCollectAsSet: #annotationTypes)) viewAnnotationConstellationOf: self on: view! !

!FAMIXClassGroup methodsFor: '*moose-mondrianpaintings' stamp: 'JurajKubelka 4/22/2013 12:11'!
viewBlueprintComplexity
	<menuItem: 'Blueprint complexity' category: 'Visualize'> 
	
	| view |
	view := ROMondrianViewBuilder new.
	self viewBlueprintOn: view.
	view openWithStatusbar setLabel: 'Blueprint complexity'! !

!FAMIXClassGroup methodsFor: '*moose-mondrianpaintings' stamp: 'JurajKubelka 4/22/2013 12:52'!
viewBlueprintOn: view
	self do: [:each | each viewBlueprintOn: view].
	view shape orthoVerticalLine width: 2; color: Color lightGray.
	view 
		edges: self mooseModel allInheritanceDefinitions 
		from: #superclass to: #subclass.
	view treeLayout verticalGap: 40.
	view root interaction menu: [:v | self mooseMenuMorph ]! !

!FAMIXClassGroup methodsFor: '*moose-mondrianpaintings' stamp: 'AnneEtien 3/8/2013 10:57'!
viewDuplicationComplexity
	"<menuItem: 'Duplication complexity' category: 'Visualize'>"
	| view |
	view := MOViewRenderer new.
	self viewDuplicationComplexityOn: view.
	^ view openWithStatusbar title: 'Duplication Complexity'! !

!FAMIXClassGroup methodsFor: '*moose-mondrianpaintings' stamp: 'tg 4/28/2010 00:45'!
viewDuplicationComplexityOn: view 
	self viewSystemComplexityOn: view.
	view shape curvedLine color: Color red.
	view interaction popupText: [:each | each duplicationText ].
	view 
		edges: self mooseModel allDuplications 
		from: [:each | each referenceCode entity] 
		to: [:each | each duplicateCode entity].! !

!FAMIXClassGroup methodsFor: '*moose-mondrianpaintings' stamp: 'TudorGirba 7/14/2011 12:32'!
viewSimpleSystemComplexityOn: view 
	view shape rectangle
		height: [ :cls | cls numberOfMethods ];
		width: [ :cls | cls numberOfAttributes ];
		linearFillColor: #numberOfLinesOfCode within: self entities.
	view interaction popupText.
	view interaction menuMorphBlock: [ :each | each mooseMenuMorph ].
	view nodes: self entities.
	view edgesFrom: [ :cls | cls superclass ].
	view treeLayout! !

!FAMIXClassGroup methodsFor: '*moose-mondrianpaintings' stamp: 'TudorGirba 7/16/2011 01:55'!
viewSimpleSystemComplexityWithSelection: selectedClassGroup height: heightBlock width: widthBlock color: colorBlock on: view
	| shape |
	shape := (MORectangleShape new 
				height: heightBlock;
				width: widthBlock;
				linearFillColor: colorBlock within: self;
				borderWidth: [:x | (selectedClassGroup includes: x) ifTrue: [3] ifFalse: [1]];
				borderColor: [:x | (selectedClassGroup includes: x) ifTrue: [Color red] ifFalse: [Color black]]
				).
	view interaction popupText.
	view interaction menuMorphBlock: [ :each | each mooseMenuMorph ].
	view nodes: self entities using: shape.
	view edgesFrom: [ :cls | cls superclass ].
	view treeLayout! !

!FAMIXClassGroup methodsFor: '*moose-mondrianpaintings' stamp: 'TudorGirba 10/10/2011 17:39'!
viewSystemComplexity
	<menuItem: 'System complexity' category: 'Visualize'> 
	| view |
	view := MOViewRenderer new.
	self viewSimpleSystemComplexityOn: view.
	^ view openWithStatusbar title: 'System Complexity'! !

!FAMIXClassGroup methodsFor: '*moose-mondrianpaintings' stamp: 'tg 1/20/2010 03:04'!
viewSystemComplexityOn: view 
	self viewSystemComplexityWithSelection: OrderedCollection new on: view! !

!FAMIXClassGroup methodsFor: '*moose-mondrianpaintings' stamp: 'TudorGirba 4/18/2011 21:49'!
viewSystemComplexityWithSelection: selectedClassGroup height: heightBlock width: widthBlock color: colorBlock on: view
	| rootClasses lonelyRootClasses shape |
	shape := (MORectangleShape new 
				height: heightBlock;
				width: widthBlock;
				linearFillColor: colorBlock within: self;
				borderWidth: [:x | (selectedClassGroup includes: x) ifTrue: [3] ifFalse: [1]];
				borderColor: [:x | (selectedClassGroup includes: x) ifTrue: [Color red] ifFalse: [Color black]]
				).
	rootClasses := self select: [:each | each isHierarchyRootWithin: self].
	lonelyRootClasses := rootClasses select: [:each | each isLonelyWithin: self].
	rootClasses := rootClasses difference: lonelyRootClasses.
	rootClasses notEmpty ifTrue: [
		view shape rectangle withoutBorder; withoutBackground.
		view node: rootClasses forIt: [
			rootClasses do: [:each | 
				view shape detailsWithTitle: [:group | group first name].
				view interaction popupText: [:group | 'Subhierarchy of ', group first printString ].
				view interaction menuMorphBlock: [ :group | group mooseMenuMorph ].
				view node: each withSubclassHierarchyGroup forIt: [
					view interaction popupView: [ :entity :popupView | 
						entity viewBlueprintOn: popupView ] zoomedInBy: 0.5.
					view interaction menuMorphBlock: [ :eachClass | eachClass mooseMenuMorph ].
					view nodes: each withSubclassHierarchy using: shape.
					view edgesFrom: #superclass.
					view treeLayout topGap: 0; leftGap: 0.
				].
			].
			view shape line color: Color lightGray.
			view flowLayout maxWidth: 600.
		] 
	].
	lonelyRootClasses notEmpty ifTrue: [
		view shape detailsWithTitle: 'Lonely classes'.
		view interaction menuMorphBlock: [ :each | each mooseMenuMorph ].
		view interaction popupText: [:group | 'Lonely classes' ].
		view node: lonelyRootClasses forIt: [
			view interaction popupView: [:entity :popupView | entity viewBlueprintOn: popupView].
			view interaction menuMorphBlock: [ :each | each mooseMenuMorph ].
			view nodes: (lonelyRootClasses sorted: [:a :b | a numberOfMethods < b numberOfMethods ] ) using: shape.
			view flowLayout maxWidth: 300; gapSize: 2.
		].
	]! !

!FAMIXClassGroup methodsFor: '*moose-mondrianpaintings' stamp: 'tg 1/21/2010 16:09'!
viewSystemComplexityWithSelection: selectedClassGroup on: view
	^ self 
		viewSystemComplexityWithSelection: selectedClassGroup 
		height: #numberOfMethods 
		width: #numberOfAttributes
		color: #numberOfLinesOfCode on: view! !

!FAMIXClassGroup methodsFor: '*moose-mondrianpaintings' stamp: 'tg 8/3/2010 19:38'!
viewTypeNestingGraphOn: view
	view shape rectangle text: #name; withoutBorder.
	view nodes: self.
	self do: [:each |
		| visitor |
		visitor := FAMIXAttributesGraphVisitor new .
		each accept: visitor.
		view edges: visitor value graph nodes from: #model toAll: [:x | x nextNodes collect: #model] ].
	view horizontalDominanceTreeLayout.! !

!FAMIXClassGroup methodsFor: '*moose-mondrianpaintings' stamp: 'tg 9/20/2009 17:24'!
viewUML
	<menuItem: 'UML class diagram' category: 'Visualize'> 
	
	| view |
	view := MOViewRenderer new.
	self viewUMLOn: view.
	view open! !

!FAMIXClassGroup methodsFor: '*moose-mondrianpaintings' stamp: 'tg 6/24/2010 22:41'!
viewUMLOn: view
	self assert: [self entities allSatisfy: [:el | el isKindOf: FAMIXClass]].
	view shape umlClass.
	view interaction popupText.
	view nodes: self entities.
	view shape: MOOrthoVerticalLineShape new.
	view edgesFrom: #superclass.
	view treeLayout horizontalGap: 10! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'Alexandre.Bergel 3/28/2009 12:12'!
abstractMethods
	"Used for the class blueprint
	Alexandre.Bergel 3/28/2009 12:10"
	^ self methods select: #isAbstract! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'simon.denier 9/21/2009 14:32'!
abstractMethodsGroup
	<navigation: 'Abstract methods'>
	
	^ FAMIXMethodGroup 	withAll: (self abstractMethods)
							withDescription: 'Abstract methods in ', self name! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'simon.denier 9/21/2009 14:30'!
accessorMethods
	
	^ self methods select: #isPureAccessor! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'simon.denier 9/21/2009 14:32'!
accessorMethodsGroup
	<navigation: 'Accessor methods'>
	
	^ FAMIXMethodGroup 	withAll: (self accessorMethods)
							withDescription: 'Pure accessors in ', self name! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'simon.denier 7/3/2009 12:21'!
constantMethods
	"Used for the class blueprint
	Alexandre.Bergel 3/28/2009 12:10"
	^ self methods select: #isConstant! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'Alexandre.Bergel 3/28/2009 12:15'!
constructors
	"Used for the class blueprint
	Alexandre.Bergel 3/28/2009 12:10"
	^ self methods select: #isConstructor! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'simon.denier 7/8/2009 15:42'!
externalFanin

	^ self clientClassesOutOfMyPackage size! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'simon.denier 7/8/2009 15:42'!
externalFanout

	^ self providerClassesOutOfMyPackage size! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'simon.denier 9/21/2009 14:38'!
fanRatio

	^ self fanIn / (self fanIn + self fanOut)! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'simon.denier 9/21/2009 14:38'!
fanTotal

	^ self fanIn + self fanOut! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'simon.denier 7/9/2009 14:56'!
fanType

	^ self externalFanin >= self internalFanin
			ifTrue: [
				self externalFanout >= self internalFanout
					ifTrue: [#eFieFo]
					ifFalse: [#eFiiFo]]
			ifFalse: [
				self externalFanout >= self internalFanout
					ifTrue: [#iFieFo]
					ifFalse: [#iFiiFo]]! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'simon.denier 9/21/2009 14:39'!
faninBalance

	| fanin |
	fanin := self fanIn.
	^ fanin = 0 	ifTrue: [0]
					ifFalse: [(self externalFanin - self internalFanin) / self fanIn]! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'simon.denier 9/21/2009 14:39'!
fanoutBalance

	^ (self externalFanout - self internalFanout) / self fanOut! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'Alexandre.Bergel 3/28/2009 12:11'!
getterMethods
	"Used for the class blueprint
	Alexandre.Bergel 3/28/2009 12:10"
	^ self methods select: #isGetter! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'Alexandre.Bergel 3/28/2009 12:20'!
implementationMethods
	^ self methods select: #isInternalImplementation! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'simon.denier 7/3/2009 14:11'!
initializers

	^ self methods select: #isInitializer! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'simon.denier 7/3/2009 14:17'!
interfaceMethods
	^ self methods select: [:each | each isInternalImplementation not & each isInitializer not & each isPureAccessor not]! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'simon.denier 7/8/2009 15:44'!
internalFanin

	^ self clientClassesIntoMyPackage size! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'simon.denier 7/8/2009 15:44'!
internalFanout

	^ self providerClassesIntoMyPackage size! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'simon.denier 7/3/2009 17:37'!
internalInvocations

	^ self outgoingInvocationsGroup select: [:each | 
				each candidates anySatisfy: [:c|
					c belongsTo == self ]].
! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'simon.denier 7/3/2009 17:46'!
internalLayerInvocations

	^ self outgoingInvocationsGroup select: [:each | 
			each sender isInternalImplementation and: [ "internal sender"
				each candidates anySatisfy: [:cand|
					cand belongsTo == self and: [ "class candidate"
						each sender ~= cand and: [ "no recursive call"
							cand isInternalImplementation ]]]]] "internal candidate"
! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'Alexandre.Bergel 3/28/2009 12:12'!
overridingMethods
	"Used for the class blueprint
	Alexandre.Bergel 3/28/2009 12:10"
	^ self methods select: #isOverriding! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'Alexandre.Bergel 3/28/2009 12:11'!
setterMethods
	"Used for the class blueprint
	Alexandre.Bergel 3/28/2009 12:10"
	^ self methods select: #isSetter! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'tg 8/3/2010 19:39'!
viewTypeNestingGraphOn: view
	| visitor |
	visitor := FAMIXAttributesGraphVisitor new .
	self accept: visitor.
	view nodes: visitor value graph nodes.
	view edges: visitor value graph nodes from: #yourself toAll: #nextNodes.
	view horizontalDominanceTreeLayout! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'tg 9/20/2009 17:11'!
viewUML
	<menuItem: 'UML class diagram' category: 'Visualize'> 
	
	| view |
	view := MOViewRenderer new.
	self viewUMLOn: view.
	view open! !

!FAMIXClass methodsFor: '*moose-mondrianpaintings' stamp: 'tg 9/29/2009 11:24'!
viewUMLOn: view
	view shape umlClass.
	view interaction popupText.
	view node: self

! !

!FAMIXPackage methodsFor: '*moose-mondrianpaintings' stamp: 'RobertVonBurg 11/15/2012 13:21'!
browsePackageBlueprints
	"<menuItem: 'Browse Package Blueprints' category: 'Visualize'> "

	PackageBlueprint openBlueprintBrowserOn: { self }! !

!FAMIXNamespaceGroup methodsFor: '*moose-mondrianpaintings' stamp: 'tg 2/20/2010 21:31'!
viewDependenciesWithCycles
	<menuItem: 'Dependencies (cycles)' category: 'Visualize'>
	|view |
	view := MOViewRenderer new.
	self viewDependenciesWithCyclesOn: view.
	^ view open! !

!FAMIXNamespaceGroup methodsFor: '*moose-mondrianpaintings' stamp: 'TudorGirba 10/17/2012 10:21'!
viewDependenciesWithCyclesOn: view
	
	| tarjan |	
	tarjan := MalTarjan new.
	tarjan nodes: self.
	tarjan edges: self from: #yourself toAll: #providerNamespaces.
	tarjan run.

	view shape rectangle
		width: #numberOfClasses; 
		height: [:each | each numberOfMethods / 10];
		fillColor: [ :namespace|
			(tarjan findNode: namespace) isInCycle
				ifTrue: [Color red]
				ifFalse: [Color white]].
	view interaction popupText: #mooseDisplayString.
	view nodes: self.
	view shape line color: Color veryLightGray.
	view edges: self from: #yourself toAll: #providerNamespaces.
	view dominanceTreeLayout layered
	! !

!FAMIXNamespaceGroup methodsFor: '*moose-mondrianpaintings' stamp: 'tg 2/7/2010 10:38'!
viewHierarchy
	<menuItem: 'Namespace Hierarchy' category: 'Visualize'>
	| view |
	view := MOViewRenderer new.
	self viewHierarchyOn: view.
	^ view open.! !

!FAMIXNamespaceGroup methodsFor: '*moose-mondrianpaintings' stamp: 'TudorGirba 10/20/2011 15:03'!
viewHierarchyOn: view
	view shape label text: #name.
	view interaction menuMorphBlock: [ :each | each mooseMenuMorph ].
	view nodes: self.
	view shape horizontalOrthogonalLine color: Color veryLightGray.
	view edgesFrom: #belongsTo.
	view horizontalTreeLayout layered! !

!FAMIXNamespaceGroup methodsFor: '*moose-mondrianpaintings' stamp: 'TudorGirba 9/23/2011 14:09'!
viewSystemDependencies
	<menuItem: 'System Overview' category: 'Visualize'>

	| view |
	view := MOViewRenderer new.
	self viewSystemDependenciesOn: view.
	view open! !

!FAMIXNamespaceGroup methodsFor: '*moose-mondrianpaintings' stamp: 'TudorGirba 9/23/2011 14:09'!
viewSystemDependenciesOn: view
	| tarjan classes |	
	tarjan := MalTarjan new.
	tarjan nodes: self.
	tarjan edges: self from: #yourself toAll: #providerNamespaces.
	tarjan run.

	classes := self flatCollect: [:nm | nm classes].

	view shape: (MORectangleShape new
		borderColor: [:namespace|
		(tarjan findNode: namespace) isInCycle
			ifTrue: [Color red]
			ifFalse: [Color black]]).
	view 	nodes: (self entities asSortedCollection: [:a :b | a classes size > b classes size])
			forEach: [:namespace |
		"(MooseGroup withAll: namespace classes) viewSystemComplexityOn: view"
				view shape: (MORectangleShape new
								width: #numberOfAttributes;
								height: #numberOfMethods;
								linearFillColor: #numberOfLinesOfCode within: classes).
			view nodes: (namespace classes asSortedCollection: 
												[:a :b | a numberOfLinesOfCode > b numberOfLinesOfCode]).
			view gridLayout ].
"	view edgeShape: (MOStraightLineShape new color: Color black).
	view edges: self from: #yourself toAll: #providerNamespaces."
	view gridLayout! !

!FAMIXNamespaceGroup methodsFor: '*moose-mondrianpaintings' stamp: 'TudorGirba 11/29/2011 16:01'!
viewWithinOverallHierarchy
	<menuItem: 'Within overall hierarchy' category: 'Visualize'>
	| view |
	view := MOViewRenderer new.
	self viewWithinOverallHierarchyOn: view.
	view openWithStatusbar! !

!FAMIXNamespaceGroup methodsFor: '*moose-mondrianpaintings' stamp: 'TudorGirba 11/29/2011 16:03'!
viewWithinOverallHierarchyOn: view 
	view shape rectangle withoutBorder 
		text: #name;
		fontSize: [:each | (self includes: each) ifTrue: [10] ifFalse: [5] ].
	view nodes: (self flatCollectAsSet: #withAllParentScopes).
	view shape horizontalOrthogonalLine color: Color veryLightGray.
	view edgesFrom: #parentScope.
	view horizontalTreeLayout layered! !

!FAMIXPackageGroup methodsFor: '*moose-mondrianpaintings' stamp: 'RobertVonBurg 11/15/2012 13:22'!
browsePackageBlueprints
	"<menuItem: 'Browse Package Blueprints' category: 'Visualize'>"

	PackageBlueprint openBlueprintBrowserOn: self! !

!FAMIXPackageGroup methodsFor: '*moose-mondrianpaintings' stamp: 'tg 2/20/2010 21:31'!
viewDependenciesWithCycles
	<menuItem: 'Dependencies (cycles)' category: 'Visualize'>
	|view |
	view := MOViewRenderer new.
	self viewDependenciesWithCyclesOn: view.
	view open! !

!FAMIXPackageGroup methodsFor: '*moose-mondrianpaintings' stamp: 'RobertVonBurg 11/15/2012 13:39'!
viewDependenciesWithCyclesOn: aView
	
	| view tarjan colorDic colors color |	
	tarjan := MalTarjan new.
	tarjan nodes: self.
	tarjan edges: self from: #yourself toAll: [:each | each querySureOutgoingAssociations atPackageScope withoutSelfLoops ].
	tarjan run.

	colorDic := IdentityDictionary new.
	colors := MOCircularColors new.	
	tarjan nodes do: [ :n | 
		n isInCycle 
			ifTrue: [
				colorDic at: n model ifAbsentPut: [
					color := colors nextColor.
					n cycleNodes do: [:cn| colorDic at: cn model ifAbsentPut: [color] ].
					color] ]
			ifFalse: [
				colorDic at: n model ifAbsentPut: [Color white] ]
		].

	aView shape rectangle
		width: #numberOfClasses; 
		height: [:each | each numberOfMethods / 10];
		borderColor: Color gray;
		fillColor: [ :each | colorDic at: each].
"	aView shape: (MORectangleShape new
		text: [:p | p name truncateWithElipsisTo: 20];
		fillColor: [:p| colorDic at: p]).
"	aView interaction item: 'View DSM' action: [:el | 
			| packages vie node|
			node := (tarjan findNode: el).
			packages := FAMIXPackageGroup new.
			packages
				add: el;
				addAll: (node cycleNodes collect:[:e | e model]).
			vie := MOViewRenderer new.
			packages viewDSMOn: vie.
			vie openDSM
	].
	aView nodes: self.
	aView edges: self from: #yourself toAll: #providerPackages.
	aView dominanceTreeLayout.! !

!FAMIXPackageGroup methodsFor: '*moose-mondrianpaintings' stamp: 'tg 9/20/2009 17:12'!
viewSystemComplexity
	<menuItem: 'Package-wise System Complexity' category: 'Visualize'> 

	| view | 
	view := MOViewRenderer new.
	self viewSystemComplexityOn: view.
	view open.! !

!FAMIXPackageGroup methodsFor: '*moose-mondrianpaintings' stamp: 'RobertVonBurg 11/15/2012 13:46'!
viewSystemComplexityOn: view

	view nodes: self forEach: [:p|
		p localClassesGroup isEmpty ifFalse: [
			p localClassesGroup viewSystemComplexityOn: view ] ].
	view shape verticalOrthogonalLine.
	view edges: self from: #yourself toAll: [:each | each queryIncomingInheritances atPackageScope ].
	view dominanceTreeLayout! !

!MooseModel methodsFor: '*Moose-MondrianPaintings-OverviewPyramid' stamp: 'TudorGirba 5/8/2011 22:26'!
viewOverviewPyramidMap
	<menuItem: 'Overview pyramid' category: 'Visualize'> 
	
	(OverviewPyramid on: self) open.
		! !

!MooseEntity methodsFor: '*moose-mondrianpaintings' stamp: 'TudorGirba 9/20/2011 17:19'!
openInEasel

	| symbol className prefixesToIgnore |
	prefixesToIgnore := #( 'FAMIX' 'MSE' 'Moose').
	className := self class name asString.
	prefixesToIgnore do: [:each |
		(className beginsWith: each) ifTrue: [
			className := className copyFrom: each size + 1 to: className size] ].
	symbol := className at: 1 put: className first asLowercase; yourself.
	MOEasel openOn: symbol asSymbol -> self ! !

!FAMIXAnnotationTypeGroup methodsFor: '*Moose-MondrianPaintings' stamp: 'tg 5/12/2010 10:49'!
viewAnnotationConstellation
	<menuItem: 'Annotation Constellation' category: 'Visualize'>
	| view |
	view := MOViewRenderer new.
	self viewAnnotationConstellationOn: view.
	^ view openWithStatusbar title: 'Annotation Constellation'! !

!FAMIXAnnotationTypeGroup methodsFor: '*Moose-MondrianPaintings' stamp: 'TudorGirba 12/12/2012 01:38'!
viewAnnotationConstellationOf: aClassGroup on: view
	| annotated classes layoutClass |

	view shape rectangle 
		text: #name;
		fillColor: Color gray;
		fontColor: Color white;
		linearFontSize: [:each | 
			(MooseGroup withAll: 
					(each annotatedEntities, 
					(each annotatedEntities collect: #belongsTo)) asSet) allClasses size ] within: self;
		withoutBorder.
	view interaction menu: #mooseMenuMorph.
	view nodes: (self select: [:each | each annotatedEntities notEmpty ]).
	annotated := self flatCollect: #annotatedEntities.
	view shape ellipse fillColor: Color lightGray; withoutBorder.
	view interaction menu: #mooseMenuMorph.
	view nodes: aClassGroup.

	view shape line color: Color veryVeryLightGray; width: 3.
	view edges: self fromAll: #annotatedEntities to: #yourself.
	view shape line color: Color veryVeryLightGray.
	view edges: self fromAll: [:each | each annotatedEntities collect: #belongsTo] to: #yourself.
	layoutClass := Smalltalk at: #MOGraphVizLayout ifAbsent: [MOForceBasedLayout].
	view layout: layoutClass new! !

!FAMIXAnnotationTypeGroup methodsFor: '*Moose-MondrianPaintings' stamp: 'tg 5/7/2010 01:13'!
viewAnnotationConstellationOn: view
	| annotated classes |

	annotated := self flatCollect: #annotatedEntities.
	classes := annotated allClasses asSet.
	classes addAll: (annotated allMethods collect: #parentType).
	self viewAnnotationConstellationOf: classes on: view! !

!HismoClassHistoryGroup methodsFor: '*moose-mondrianpaintings' stamp: 'tg 9/20/2009 17:28'!
viewEvolutionMatrix
	| view |	
	view := MOViewRenderer new.
	self viewEvolutionMatrixOn: view.
	view open! !

!HismoClassHistoryGroup methodsFor: '*moose-mondrianpaintings' stamp: 'jannik.laval 9/2/2009 16:36'!
viewEvolutionMatrixOn: view 
	| builder temp y x |
	"<mondrianView: 'viewEvolutionMatrixOn: view '>"
	builder := MOFormsBuilder new.
	temp := self
				sorted: [:a :b | a first referenceVersion < b first referenceVersion].
	self size
		timesRepeat: [builder row; pref; row; size: 5].
	self referenceHistory size
		timesRepeat: [builder column; pref; column; size: 5].
	y := 1.
	temp
		do: [:eachHistory | 
			x := 1.
			eachHistory
				completeHistoryDo: [:eachVersion | 
					view shape rectangle 
						width: #numberOfLinesOfCode;
						height: #numberOfMethods.
					builder
						x: x
						y: y
						add: (view node: eachVersion).
					x := x + 2]
				ifNotPresent: [:zzz | x := x + 2].
			y := y + 2].
	view layout: builder asLayout
! !

!MooseGroup methodsFor: '*Moose-MondrianPaintings' stamp: 'StephanEggermont 9/10/2012 16:27'!
symbolsUsedInName
	| symbols nospace noseparator |
	symbols := self asOrderedCollection flatCollect: [:each |
		nospace := (each name piecesCutWhere: [:a :b | {Character space. $_} includes: a]) collect: [:token | (token replaceAll: $_ with: Character space) trimRight trimLeft ].
		nospace flatCollect: [:x | x piecesCutWhereCamelCase collect: [:y | each -> (MalStemmer English stem: y) ]]
	].
	^(symbols reject: [:each | MooseUtilities stopWordList includes: each value]) 
			groupedBy: #value affect: [:assocCol | assocCol collect: #key]! !

!MooseGroup methodsFor: '*Moose-MondrianPaintings' stamp: 'tg 5/12/2010 10:49'!
viewNameCloud
	<menuItem: 'Name Cloud' category: 'Visualize'>
	| view |
	view := MOViewRenderer new.
	self viewNameCloudOn: view.
	^ view openWithStatusbar title: 'Name Cloud'! !

!MooseGroup methodsFor: '*Moose-MondrianPaintings' stamp: 'tg 4/26/2010 23:13'!
viewNameCloudOn: view 
	| symbols objects |
	symbols := self symbolsUsedInName.
	objects := (symbols associations asSortedCollection: [:a : b | a value size > b value size]) asOrderedCollection.
	view shape label
		text: [:each | each key];
		linearFontSize: [:each | each value size] within: objects
"		textColor: (MONColorLinearNormalizer inContext: objects withCommand: [:each | each value size] 
											   lowColor: Color white lowThreshold: 0.1 
											   highColor: Color black highThreshold: 0.9)".
	view interaction popupText: [:each | each value size asString ].
	view nodes: objects.
	view bottomFlowLayout maxWidth: 600! !

!FAMIXMethod methodsFor: '*moose-mondrianpaintings' stamp: 'Alexandre.Bergel 4/21/2009 00:22'!
blueprintFillColor
	
	self isPureAccessor ifTrue: [ ^ Color orange].
	
	self isSetter ifTrue: [ ^ Color red].

	self isGetter ifTrue: [ ^ Color orange].

	self isAbstract ifTrue: [ ^ Color cyan].

	self isOverriding ifTrue: [ ^ Color brown].

	self isConstant ifTrue: [ ^ Color gray].
	
	^ Color white.! !

!HismoAbstractHistory methodsFor: '*moose-mondrianpaintings' stamp: 'JurajKubelka 4/1/2013 15:32'!
viewSimpleEvolutionMatrix
	<menuItem: 'Evolution matrix' category: 'Visualize'>
	| view |
	
	view := ROMondrianViewBuilder new.
	self viewSimpleEvolutionMatrixIn: view.
	^ view open! !

!HismoAbstractHistory methodsFor: '*moose-mondrianpaintings' stamp: 'JurajKubelka 4/1/2013 15:31'!
viewSimpleEvolutionMatrixIn: aView
	
	aView shape rectangle fillColor: [:x | Color lightGray]; withoutBorder.
	aView 
		node: self 
		forIt: [
			aView shape rectangle 
				withoutBorder; 
				fillColor: [:each | each == each referenceVersion ifTrue: [Color lightGray] ifFalse: [Color white] ].
			aView nodes: (self completeHistoryCollect: [:each | each] 
										ifNotPresent: [:eachRefVersion | eachRefVersion]).
		]! !

MalGraphNode subclass: #MOLayerNode
	instanceVariableNames: 'layer nextNodes nextCyclicNodes fillColor borderColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-MondrianPaintings-LayerTable'!

!MOLayerNode methodsFor: 'accessing' stamp: 'simon.denier 7/23/2009 00:04'!
borderColor
	^ borderColor! !

!MOLayerNode methodsFor: 'accessing' stamp: 'simon.denier 7/23/2009 00:04'!
borderColor: anObject
	borderColor := anObject! !

!MOLayerNode methodsFor: 'accessing' stamp: 'simon.denier 7/29/2009 23:00'!
commonNodes: aLayerNode
	"refactor to trait - MOCycleEdge"
	^ self nodes intersection: aLayerNode nodes! !

!MOLayerNode methodsFor: 'accessing' stamp: 'simon.denier 7/23/2009 00:04'!
fillColor
	^ fillColor! !

!MOLayerNode methodsFor: 'accessing' stamp: 'simon.denier 7/23/2009 00:04'!
fillColor: anObject
	fillColor := anObject! !

!MOLayerNode methodsFor: 'initialize-release' stamp: 'simon.denier 7/24/2009 16:17'!
initialize

	nextNodes := OrderedCollection new.
	borderColor := Color black.
	fillColor := Color white.! !

!MOLayerNode methodsFor: 'accessing' stamp: 'simon.denier 7/24/2009 17:57'!
label

	^ 'L '! !

!MOLayerNode methodsFor: 'accessing' stamp: 'simon.denier 7/23/2009 00:04'!
layer
	^ layer! !

!MOLayerNode methodsFor: 'accessing' stamp: 'simon.denier 7/23/2009 00:04'!
layer: anObject
	layer := anObject! !

!MOLayerNode methodsFor: 'accessing' stamp: 'simon.denier 7/23/2009 00:04'!
model
	^ model! !

!MOLayerNode methodsFor: 'accessing' stamp: 'simon.denier 7/23/2009 00:04'!
model: anObject
	model := anObject! !

!MOLayerNode methodsFor: 'accessing' stamp: 'simon.denier 7/23/2009 00:04'!
nextCyclicNodes
	^ nextCyclicNodes! !

!MOLayerNode methodsFor: 'accessing' stamp: 'simon.denier 7/23/2009 00:04'!
nextCyclicNodes: anObject
	nextCyclicNodes := anObject! !

!MOLayerNode methodsFor: 'accessing' stamp: 'simon.denier 7/23/2009 00:04'!
nextNodes
	^ nextNodes! !

!MOLayerNode methodsFor: 'accessing' stamp: 'simon.denier 7/23/2009 00:04'!
nextNodes: anObject
	nextNodes := anObject! !

!MOLayerNode methodsFor: 'accessing' stamp: 'simon.denier 7/29/2009 23:06'!
nodes

	^ self nextNodes copyWith: self! !

!MOLayerNode methodsFor: 'accessing' stamp: 'simon.denier 7/29/2009 23:00'!
similarity: aLayerNode
	"refactor to trait - MOCycleEdge"
	^ (self commonNodes: aLayerNode) size! !

!MOLayerNode methodsFor: 'accessing' stamp: 'simon.denier 7/24/2009 16:09'!
to: aNode

	nextNodes add: aNode! !

Object subclass: #MOFameView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-MondrianPaintings-FameView'!

!MOFameView methodsFor: 'private' stamp: 'TudorGirba 3/27/2011 12:12'!
allFamixMetamodel
	"
	I use FMPragmaProcessor to be strict with respect to meta declarations.
	"
	| tower famixDescriptionClasses |
	tower := self 
		metaBuilder: FAMIXEntity withAllSubclasses
		withProcessor: FMPragmaProcessor new.
	^ tower metamodel! !

!MOFameView methodsFor: 'private' stamp: 'tg 2/28/2010 00:29'!
fameShape
	| builder bodyLabel |
	builder := MOFormsBuilder new.
	builder column; fill.
	builder row; fill; row; fill.
	builder x: 1 y: 1 add: (MORectangleShape new text: [ :cls | cls name ]; textPadding: 5).
	builder x: 1 y: 2 add: MORectangleShape new.
	bodyLabel :=  [ :cls | | label | 
			label := cls attributes 
				inject: ''
				into: [ :sum :el | sum ,(self propertyLabel: el) , String cr ].
				label copyFrom: 1 to: ((label size -1) max: 0)   ].
	builder x: 1 y: 2 add: (MORectangleShape new textPadding: 5; text: bodyLabel).
	^ builder shape! !

!MOFameView methodsFor: 'opening' stamp: 'TudorGirba 9/13/2011 20:17'!
open
	^ self openOn: MooseModel meta! !

!MOFameView methodsFor: 'opening' stamp: 'TudorGirba 9/13/2011 20:24'!
openOn: aMetamodel 
	"
		self new openOn: MooseModel meta
	"

	| view famixClasses |
	view := MOViewRenderer new.
	famixClasses := aMetamodel classes select: [:fameClass | fameClass package name == #FAMIX].
	self viewFameClasses: famixClasses on: view.
	view open! !

!MOFameView methodsFor: 'private' stamp: 'simon.denier 3/5/2009 17:04'!
propertyLabel: aFM3Property
	
	^ String streamContents: [ :str |
		( aFM3Property isDerived ) ifTrue: [ str nextPut: $/ ].
		str nextPutAll: aFM3Property name copy.
		str nextPut: $: ; nextPut: $ ; nextPutAll: aFM3Property type name.
		( aFM3Property isMultivalued ) ifTrue: [ str nextPut: $* ].
		( aFM3Property hasOpposite ) ifTrue: [ str nextPutAll: ' -> ', aFM3Property opposite name ]		
	]
! !

!MOFameView methodsFor: 'private' stamp: 'TudorGirba 9/13/2011 20:20'!
viewFameClasses: classes on: view

	view interaction draggable.
	view shape: self fameShape.
	view nodes: classes.
	view edgeShape:  MOOrthoHorizontalLineShape new.
	view edgesFrom: #superclass.
	view horizontalTreeLayout verticalGap: 10.! !

!MOFameView methodsFor: 'private' stamp: 'TudorGirba 3/27/2011 12:12'!
viewFamixCore
	" This method displays Famix core classes i.e., Famix classes declared in FAMIX package.
		self new viewFamixCore.
		famixClasses := self allFamixMetamodel classes select: [ :fameClass | fameClass package name = #FAMIX ].
	"
	| view |
	view := MOViewRenderer new.
	self 
		viewFameClasses: (self allFamixMetamodel classes select: [ :fameClass | fameClass package name = #FAMIX ])
		on: view.
	view open
	! !

!MOFameView methodsFor: 'private' stamp: 'TudorGirba 3/27/2011 12:12'!
viewFamixMetamodel
	" This method displays ALL Famix classes currently loaded i.e., subclasses of FAMIXEntity.
		self new viewFamixMetamodel
	"
	| view |
	view := MOViewRenderer new.
	self 
		viewFameClasses: self allFamixMetamodel classes
		on: view.
	view open! !

!MOFameView methodsFor: 'private' stamp: 'TudorGirba 3/27/2011 12:12'!
viewFamixMetamodel: aCollectionOfFamePackages
	" This method displays Famix classes part of the given Fame packages.
		self new viewFamixMetamodel: {'FAMIX'. 'ASPIX'} 
	"
	| view classes metamodel |
	view := MOViewRenderer new.
	metamodel := self allFamixMetamodel.
	classes := aCollectionOfFamePackages flatCollect: [:pname| (metamodel packageNamed: pname) classes ].
	self 
		viewFameClasses: classes
		on: view.
	view open! !

Object subclass: #MOLayerTable
	instanceVariableNames: 'layers orderedNodes cellSize cellPadding textLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-MondrianPaintings-LayerTable'!

!MOLayerTable methodsFor: 'drawing' stamp: 'simon.denier 10/8/2009 16:09'!
addDependencyColumnFor: node view: view rows: nbRows 
	| depLayers maxCells |
	depLayers := SmallDictionary new.
	1 to: nbRows do: [:i| 
		depLayers at: i put: OrderedCollection new ].
	node nextNodes do: [ :next | (depLayers at: next layer) add: next ].
	(depLayers at: node layer) add: node.

	maxCells := (depLayers detectMax: [ :l | l size ]) size.
	view shape: (self enclosingShapeFor: maxCells).
	view nodes: depLayers forEach: [:dlayer| 
		dlayer isEmpty
		ifTrue: [
			view shape: self whiteShape.
			view node: #void ]
		ifFalse: [
			view interaction popupText: [:n | textLabel moValue: n].
			view shape: (self cellShapeWithSource: node).
			view nodes: dlayer ].
		view layout: (MOHorizontalLineLayout new gapSize: (self cellPadding // 2))
	]! !

!MOLayerTable methodsFor: 'sample' stamp: 'tg 10/6/2010 18:44'!
applyDefaultBorderColorStrategy

	| queue tarjan color |
	queue := MOCircularColors new.
	tarjan := MalTarjan new.
	tarjan nodes: self nodes.
	tarjan edges: self edges from: #first to: #second.
	tarjan run.
	
	"this is a hack: temporarily nilling all bordercolors"
	self nodes do: [:n|
		n borderColor: nil ].
	
	tarjan nodes do: [:n|
		n isInCycle
			ifTrue: [
				n model borderColor ifNil: [
					color := queue nextColor.
					n model borderColor: color.
					n cycleNodes do: [:cn| 
						cn model borderColor: color ]
					]]
			ifFalse: [ "reset default color"
				n model borderColor: Color black]
	]! !

!MOLayerTable methodsFor: 'sample' stamp: 'simondenier 5/4/2010 16:31'!
applyDefaultFillColorStrategy

	| queue previousCounts count fanin fanout |
	queue := MOCircularColors new.

	"dumb way to count incoming dependencies.
	remember, it's just a sample"
	previousCounts := SmallDictionary new.
	self nodes do: [:node|
		previousCounts at: node ifAbsentPut: 0.
		node nextNodes do: [:next|
			count := previousCounts at: next ifAbsentPut: 0.
			previousCounts at: next put: count + 1 ]
		].

	self nodes do: [:node|
		fanin := (previousCounts at: node).
		fanout := node nextNodes size.
		((fanin > 0 and: [fanout >0]) or: [fanin > 1]) ifTrue: [
			node fillColor: (queue nextColor alphaMixed: 0.5 with: Color white) ]
	]! !

!MOLayerTable methodsFor: 'drawing' stamp: 'simon.denier 7/29/2009 23:44'!
applyDefaultNodes

	orderedNodes := self nodes! !

!MOLayerTable methodsFor: 'sample' stamp: 'tg 10/6/2010 18:44'!
applyDominanceFillColorStrategy

	| queue dom dominantColors color |
	queue := MOCircularColors new.

	dom := MalDominance new.
	dom nodes: self nodes.
	dom edges: self edges from: #first to: #second.
	dom run.

	dominantColors := SmallDictionary new.
	dom nodes do: [:node|
		node isDominant ifTrue: [
			color := dominantColors at: node ifAbsentPut: (queue nextColor alpha: 0.5).
			node model fillColor: color.
		].
		node isDominated ifTrue: [
			color := dominantColors at: node dominantNode ifAbsentPut: (queue nextColor alphaMixed: 0.5 with: Color white).
			node model fillColor: color.
		]
	]! !

!MOLayerTable methodsFor: 'drawing' stamp: 'simon.denier 7/29/2009 23:44'!
applySimilarityNodes

	orderedNodes := MOLayerTableOrganizer new initializeNodeOrderWith: self nodes! !

!MOLayerTable methodsFor: 'accessing' stamp: 'simon.denier 10/8/2009 15:42'!
cellPadding
	^ cellPadding! !

!MOLayerTable methodsFor: 'accessing' stamp: 'simon.denier 10/8/2009 15:42'!
cellPadding: anObject
	cellPadding := anObject! !

!MOLayerTable methodsFor: 'drawing' stamp: 'simon.denier 10/8/2009 15:47'!
cellShapeWithSource: sNode

	^ MOFixedRectangleShape new
			size: self cellSize;
			borderWidth: [:n| n = sNode ifTrue: [3] ifFalse: [1]];
			borderColor: [:n| n borderColor];
			fillColor: [:n| n fillColor];
			text: [:n| textLabel moValue: n]! !

!MOLayerTable methodsFor: 'accessing' stamp: 'simon.denier 7/29/2009 16:44'!
cellSize

	^ cellSize! !

!MOLayerTable methodsFor: 'accessing' stamp: 'simon.denier 7/29/2009 16:45'!
cellSize: anInteger

	cellSize := anInteger! !

!MOLayerTable methodsFor: 'sample' stamp: 'simon.denier 7/24/2009 18:51'!
edges

	^ self nodes 	inject: OrderedCollection new
					into: [:c :n| n nextNodes do: [:t| c add: {n. t}]. c]! !

!MOLayerTable methodsFor: 'drawing' stamp: 'simon.denier 10/8/2009 15:45'!
enclosingShapeFor: nbCells

	^ MOFixedRectangleShape new
			borderColor: Color lightGray;
			height: self cellSize + self cellPadding;
			width: nbCells * (self cellSize + self cellPadding)! !

!MOLayerTable methodsFor: 'accessing' stamp: 'simon.denier 10/8/2009 16:10'!
initialize

	cellSize := 30.
	cellPadding := 10.
	textLabel := [:node| node model asString].! !

!MOLayerTable methodsFor: 'accessing' stamp: 'simon.denier 7/22/2009 23:49'!
layers
	^ layers! !

!MOLayerTable methodsFor: 'accessing' stamp: 'simon.denier 7/22/2009 23:49'!
layers: anObject
	layers := anObject! !

!MOLayerTable methodsFor: 'accessing' stamp: 'simon.denier 7/24/2009 17:41'!
nodes

	^ layers inject: OrderedCollection new into: [:c :layer| c addAll: layer. c]! !

!MOLayerTable methodsFor: 'drawing' stamp: 'simon.denier 7/29/2009 16:42'!
render

	| view |
	view := MOViewRenderer new.
	self renderOn: view.
	view open.! !

!MOLayerTable methodsFor: 'drawing' stamp: 'simon.denier 7/29/2009 23:46'!
renderOn: view 
	| nbRows |
	
	nbRows := layers size.
	orderedNodes ifNil: [self applyDefaultNodes].
	
	view node: #layers forIt: [
		view shape: ((self enclosingShapeFor: 1)
									text: [:l| l value size printString]).
		view nodes: layers associations.
		view verticalLineLayout gapSize: -1.
	].
	
	orderedNodes do: [ :node | 
		node nextNodes isEmpty ifFalse: [
			view node: node forIt: [
				self addDependencyColumnFor: node view: view rows: nbRows.
				view verticalLineLayout gapSize: -1]]
	].
	view horizontalLineLayout gapSize: 0.! !

!MOLayerTable methodsFor: 'sample' stamp: 'simon.denier 10/8/2009 16:11'!
renderSample
	"self new renderSample"

	self renderSampleWith: #applyDefaultFillColorStrategy.! !

!MOLayerTable methodsFor: 'sample' stamp: 'simon.denier 7/29/2009 23:48'!
renderSampleWith: fillColorStrategy
	"
	self new renderSampleWith: #applyDefaultFillColorStrategy.
	self new renderSampleWith: #applyDominanceFillColorStrategy.
	"

	self layers: self sample.
	fillColorStrategy moValue: self.
	self applyDefaultBorderColorStrategy.
	self applySimilarityNodes.
	self render! !

!MOLayerTable methodsFor: 'sample' stamp: 'tg 10/6/2010 18:44'!
sample

	| graph tmpLayers |
	graph := MalGraphStructure new nodeClass: MOLayerNode.
	MalGraphFixture dependencyGraph: graph.
	tmpLayers := SmallDictionary new.
	#(1 2 3 4) do: [:i| tmpLayers at: i put: OrderedCollection new].
	#($a $d) do: [:n| (tmpLayers at: 1) add: ((graph findNode: n) layer: 1)].
	#($b $e $g) do: [:n| (tmpLayers at: 2) add: ((graph findNode: n) layer: 2)].
	#($c $f $h $i) do: [:n| (tmpLayers at: 3) add: ((graph findNode: n) layer: 3)].
	#($k $j) do: [:n| (tmpLayers at: 4) add: ((graph findNode: n) layer: 4)].
	^ tmpLayers! !

!MOLayerTable methodsFor: 'accessing' stamp: 'simon.denier 10/8/2009 15:42'!
textLabel
	^ textLabel! !

!MOLayerTable methodsFor: 'accessing' stamp: 'simon.denier 10/8/2009 15:42'!
textLabel: anObject
	textLabel := anObject! !

!MOLayerTable methodsFor: 'drawing' stamp: 'simon.denier 7/29/2009 16:10'!
whiteShape
	^ MOFixedRectangleShape new
			size: self cellSize;
			borderColor: Color white! !

Object subclass: #MOLayerTableOrganizer
	instanceVariableNames: 'firstPriority secondPriority orderedNodes similarNodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-MondrianPaintings-LayerTable'!

!MOLayerTableOrganizer methodsFor: 'running' stamp: 'simon.denier 7/30/2009 00:04'!
computeSimilaritiesOf: layerNodes

	| sim |
	
	"quick and dirty, not optimized"
	similarNodes := SmallDictionary new.
	layerNodes do: [:n1|
		similarNodes at: n1 put: OrderedCollection new.
		layerNodes do: [:n2|
			n1 ~= n2 ifTrue: [
				sim := n1 similarity: n2.
				sim > 0 ifTrue: [ (similarNodes at: n1) add:  {n2. sim} ]
			]
		]		
	].! !

!MOLayerTableOrganizer methodsFor: 'running' stamp: 'simon.denier 7/30/2009 00:29'!
initializeNodeOrderWith: layerNodes 
	| node sourceNodes |
	
	orderedNodes := OrderedCollection new.
	sourceNodes := layerNodes reject: [:n| n nextNodes isEmpty].
	self initializePriorityQueuesWith: sourceNodes.
	self computeSimilaritiesOf: sourceNodes.
	
	[ self isEmpty ] whileFalse: 
		[ node := self popNode.
		orderedNodes add: node.
		"reorder to put similar stuff in front"
		self pullSimilarNodesOf: node ].
	^ orderedNodes! !

!MOLayerTableOrganizer methodsFor: 'running-private' stamp: 'simon.denier 7/30/2009 00:10'!
initializePriorityQueuesWith: nodes 
	"sort nodes by layer"

	secondPriority := (nodes asSortedCollection: [ :n1 :n2 | n1 layer < n2 layer ]) asOrderedCollection.
	"firstPriotity contains tuples of {node. similarity}"
	firstPriority := SortedCollection sortBlock: [:a1 :a2 | a1 second > a2 second]
! !

!MOLayerTableOrganizer methodsFor: 'running-private' stamp: 'simon.denier 7/29/2009 23:02'!
isEmpty

	^ firstPriority isEmpty and: [secondPriority isEmpty]! !

!MOLayerTableOrganizer methodsFor: 'accessing' stamp: 'simon.denier 7/29/2009 23:24'!
orderedNodes
	^ orderedNodes! !

!MOLayerTableOrganizer methodsFor: 'running-private' stamp: 'simon.denier 7/30/2009 00:11'!
popNode

	^ firstPriority isEmpty
		ifFalse: [firstPriority removeFirst first]
		ifTrue: [secondPriority removeFirst]! !

!MOLayerTableOrganizer methodsFor: 'running-private' stamp: 'simon.denier 7/30/2009 00:27'!
pullSimilarNodesOf: aLayerNode
	"pull similar nodes of aLayerNode in first priority queue"
	
	| tuple |
	(similarNodes at: aLayerNode) do: [ :x |
		(secondPriority includes: x first) ifTrue: [
			secondPriority remove: x first.
			firstPriority add: x "add tuple" ]
		ifFalse: [ "check if tuple in first priority, change order if similarity is better with new tuple"
			tuple := firstPriority detect: [:t| t first = x first] ifNone: [nil].
			tuple ifNotNil: [
				(x second > tuple second) ifTrue: [
					firstPriority remove: tuple.
					firstPriority add: x ]]
		]
	]! !

Object subclass: #MOTraitLayer
	instanceVariableNames: 'nodes edges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-MondrianPaintings-LayerTable'!

!MOTraitLayer methodsFor: 'as yet unclassified' stamp: 'simon.denier 9/4/2009 23:14'!
addDependencies: aBehavior

	nodes addAll: aBehavior traitComposition allTraits.
	aBehavior traitComposition allTraits do: [:t|
		edges add: {aBehavior. t} ]! !

!MOTraitLayer methodsFor: 'as yet unclassified' stamp: 'simon.denier 9/4/2009 23:15'!
runOn: aClass
	"take traitComposition from the class and add dependencies, recursively.
	 also perform on inheritance. Then run Hal to compute some layers. and finally render a layer table."
	
	nodes add: aClass.
	self addDependencies: aClass! !

Object subclass: #OverviewPyramid
	instanceVariableNames: 'mooseModel metrics moView treesholdsToUse'
	classVariableNames: 'CPPTreesholds JavaTreesholds MoosePyramidResults SmalltalkTreesholds'
	poolDictionaries: ''
	category: 'Moose-MondrianPaintings-OverviewPyramid'!

!OverviewPyramid class methodsFor: 'accessing' stamp: 'cyrilledelaunay 3/3/2011 16:42'!
callNomSymbol

	^ #CallsNom! !

!OverviewPyramid class methodsFor: 'accessing' stamp: 'cyrilledelaunay 3/3/2011 16:50'!
colorForMetricValue: aNumber fromTreesholds: aCollection

	| treesholds lowDifference averageDifference hightDifference |
	treesholds := aCollection.
	
	lowDifference := (treesholds first - aNumber) abs.
	averageDifference := (treesholds second - aNumber) abs.
	hightDifference := (treesholds third - aNumber) abs.
	
	{lowDifference. averageDifference. hightDifference} min = lowDifference ifTrue: [^ Color blue].
	{lowDifference. averageDifference. hightDifference} min = averageDifference ifTrue: [^ Color green].
	{lowDifference. averageDifference. hightDifference} min = hightDifference ifTrue: [^ Color red].
	! !

!OverviewPyramid class methodsFor: 'accessing' stamp: 'cyrilledelaunay 3/3/2011 16:36'!
cycloLocSymbol

	^ #CycloLoc! !

!OverviewPyramid class methodsFor: 'accessing' stamp: 'cyrilledelaunay 3/3/2011 16:39'!
fanoutCallsSymbol

	^ #FanoutCalls! !

!OverviewPyramid class methodsFor: 'class initialization' stamp: 'cipt 10/27/2011 19:41'!
initialize
	"self initialize"
	self initializeJavaTreesholds.
	self initializeCPPTreesholds.  
	self initializeSmalltalkTreesholds .
		
	MoosePyramidResults := Dictionary new
		at: #CycloLoc put: 0.23;
		at: #LocNom put: 6.69;
		at: #NomNoc put: 5.83;
		at: #NocNop put: 6.09;
		at: #CallsNom put: 4.18;
		at: #FanoutCalls put: 0.72;
		at: #ANDC put: 0.99;
		at: #AHH put: nil;
		yourself.! !

!OverviewPyramid class methodsFor: 'class initialization' stamp: 'cyrille.delaunay 8/9/2010 13:38'!
initializeCPPTreesholds

	CPPTreesholds := Dictionary new
		at: #CycloLoc put: (OrderedCollection withAll: #(0.20 0.25 0.30));
		at: #LocNom put: (OrderedCollection withAll: #(5 10 16));
		at: #NomNoc put: (OrderedCollection withAll: #(4 9 15));
		at: #NocNop put: (OrderedCollection withAll: #(3 19 35));
		at: #CallsNom put: (OrderedCollection withAll: #(1.17 1.58 2));
		at: #FanoutCalls put: (OrderedCollection withAll: #(0.20 0.34 0.48));
		at: #ANDC put: (OrderedCollection withAll: #(0.19 0.28 0.37));
		at: #AHH put: (OrderedCollection withAll: #(0.05 0.13 0.21));
		yourself.
		
! !

!OverviewPyramid class methodsFor: 'class initialization' stamp: 'cyrille.delaunay 8/9/2010 13:38'!
initializeJavaTreesholds

	JavaTreesholds := Dictionary new
		at: #CycloLoc put: (OrderedCollection withAll: #(0.16 0.20 0.24));
		at: #LocNom put: (OrderedCollection withAll: #(7 10 13));
		at: #NomNoc put: (OrderedCollection withAll: #(4 7 10));
		at: #NocNop put: (OrderedCollection withAll: #(6 17 26));
		at: #CallsNom put: (OrderedCollection withAll: #(2.01 2.62 3.2));
		at: #FanoutCalls put: (OrderedCollection withAll: #(0.56 0.62 0.68));
		at: #ANDC put: (OrderedCollection withAll: #(0.25 0.41 0.57));
		at: #AHH put: (OrderedCollection withAll: #(0.09 0.21 0.32));
		yourself.
! !

!OverviewPyramid class methodsFor: 'class initialization' stamp: 'cipt 10/28/2011 22:33'!
initializeSmalltalkTreesholds

	SmalltalkTreesholds := Dictionary new
		at: #CycloLoc put: (OrderedCollection withAll: #(0.16 0.22 0.27));
		at: #LocNom put: (OrderedCollection withAll: #(4.92 6.91 8.90));
		at: #NomNoc put: (OrderedCollection withAll: #(8.18 11.24 14.30));
		at: #NocNop put: (OrderedCollection withAll: #(4.63 8.57 12.50));
		at: #CallsNom put: (OrderedCollection withAll: #(3.13 5.46 7.79));
		at: #FanoutCalls put: (OrderedCollection withAll: #(0.15 0.23 0.31));
		at: #ANDC put: (OrderedCollection withAll: #(0.37 0.60 0.83));
		at: #AHH put: (OrderedCollection withAll: #(1.42 2.22 3.03));
		yourself.
! !

!OverviewPyramid class methodsFor: 'accessing' stamp: 'cyrilledelaunay 3/3/2011 16:38'!
locNomSymbol

	^ #LocNom! !

!OverviewPyramid class methodsFor: 'accessing' stamp: 'cyrilledelaunay 3/3/2011 16:36'!
nocNopSymbol

	^ #NocNop! !

!OverviewPyramid class methodsFor: 'accessing' stamp: 'cyrilledelaunay 3/3/2011 16:37'!
nomNocSymbol

	^ #NomNoc! !

!OverviewPyramid class methodsFor: 'instance creation' stamp: 'tg 4/2/2010 22:32'!
on: aMooseModel
	"(self on: MooseModel root allModels anyOne) open"
	^ super new initializeWith: aMooseModel.! !

!OverviewPyramid class methodsFor: 'accessing' stamp: 'cipt 10/27/2011 19:41'!
treesholdForModel: aMooseModel

	"return the treeshold to use for aMooseModel (it can be Java, smalltalk, cpp treeshold according the source language of the model)"
	^ SmalltalkTreesholds ! !

!OverviewPyramid methodsFor: 'accessing - metrics' stamp: 'cyrille.delaunay 5/18/2010 11:43'!
ahh

	^ metrics ahh! !

!OverviewPyramid methodsFor: 'accessing - metrics' stamp: 'cyrille.delaunay 5/18/2010 11:43'!
andc

	^ metrics andc! !

!OverviewPyramid methodsFor: 'accessing - metrics' stamp: 'cyrille.delaunay 5/18/2010 11:43'!
calls

	^ metrics calls! !

!OverviewPyramid methodsFor: 'rendering' stamp: 'cyrille.delaunay 3/17/2010 10:54'!
colorForMetric: aSymbol withValue: aNumber

	| treesholds lowDifference averageDifference hightDifference |
	treesholds := self treesholdsToUse at: aSymbol.
	
	lowDifference := (treesholds first - aNumber) abs.
	averageDifference := (treesholds second - aNumber) abs.
	hightDifference := (treesholds third - aNumber) abs.
	
	{lowDifference. averageDifference. hightDifference} min = lowDifference ifTrue: [^ Color blue].
	{lowDifference. averageDifference. hightDifference} min = averageDifference ifTrue: [^ Color green].
	{lowDifference. averageDifference. hightDifference} min = hightDifference ifTrue: [^ Color red].
	! !

!OverviewPyramid methodsFor: 'accessing - metrics' stamp: 'cyrille.delaunay 5/18/2010 11:43'!
cyclo

	^ metrics cyclo! !

!OverviewPyramid methodsFor: 'accessing - metrics' stamp: 'cyrille.delaunay 5/18/2010 11:43'!
fanout

	^ metrics fanout! !

!OverviewPyramid methodsFor: 'initialize' stamp: 'cipt 11/4/2011 20:10'!
initializeWith: aMooseModel
	| allModelMethods allModelClasses |
	mooseModel := aMooseModel.
	moView := MOViewRenderer new.
	metrics := aMooseModel overviewPyramidMetrics.
	self treesholdsToUse: SmalltalkTreesholds 
	! !

!OverviewPyramid methodsFor: 'accessing - metrics' stamp: 'cyrille.delaunay 5/18/2010 11:42'!
loc

	^ metrics loc! !

!OverviewPyramid methodsFor: 'accessing - metrics' stamp: 'cyrille.delaunay 5/18/2010 11:42'!
noc 

	^ metrics noc! !

!OverviewPyramid methodsFor: 'accessing - metrics' stamp: 'cyrille.delaunay 5/18/2010 11:42'!
nom

	^ metrics nom! !

!OverviewPyramid methodsFor: 'accessing - metrics' stamp: 'cyrille.delaunay 5/18/2010 11:51'!
nop

	^ metrics nop! !

!OverviewPyramid methodsFor: 'opening' stamp: 'cyrille.delaunay 8/9/2010 13:46'!
open

	self render.
	moView open! !

!OverviewPyramid methodsFor: 'rendering' stamp: 'cyrille.delaunay 6/23/2010 16:41'!
render
	
	^ self renderOn: moView ! !

!OverviewPyramid methodsFor: 'rendering' stamp: 'TudorGirba 11/16/2011 09:22'!
renderOn: aView
	aView shape rectangle withoutBorder.
	aView node: #greenAndyellow forIt: [
		aView shape rectangle width: 70; height: 30; withoutBorder ; fillColor: Color paleGreen.
		aView node: #ANDC forIt: [
			aView interaction popupText: [:n | 'Average Number of Derived Classes']. 
			aView shape label fillColor: Color paleGreen.
			aView node: 'ANDC' ].
		aView shape rectangle width: 70; height: 30; withoutBorder ; fillColor: Color paleGreen.
		aView node: #AHH forIt: [
			aView interaction popupText: [:n | 'Average Hierarchy Height']. 
			aView shape label fillColor: Color paleGreen.
			aView node: 'AHH' ].
		aView shape rectangle width: 150; height: 30; withoutBorder ; fillColor: Color paleYellow.
		aView node: #NOP forIt: [ |nocNop|
			nocNop := self noc / self nop.
			aView interaction popupText: [:n | 'High-level Structuring (NOC/Package). Indicates if packages tend to be coarse grained or fine grained'].
			aView shape label fillColor: (self colorForMetric: #NocNop withValue: nocNop); fontColor: Color white.
			aView node: (self truncatedStringForFraction: nocNop) .
			aView interaction popupText: [:n | 'Number Of Packages']. 
			aView shape label fillColor: Color paleYellow.
			aView node: 'NOP' ].
		aView shape rectangle width: 200; height: 30; withoutBorder ; fillColor: Color paleYellow.
		aView node: #NOC forIt: [ |nomNoc|
			nomNoc := self nom / self noc.
			aView interaction popupText: [:n | 'Class structuring (NOM/Class). Reveals how operations are dirstributed among classes'].
			aView shape label fillColor: (self colorForMetric: #NomNoc withValue: nomNoc); fontColor: Color white.
			aView node: (self truncatedStringForFraction: nomNoc).
			aView interaction popupText: [:n | 'Number Of Classes']. 
			aView shape label fillColor: Color paleYellow.
			aView node: 'NOC' ].
		aView shape rectangle width: 250; height: 30; withoutBorder ; fillColor: Color paleYellow.
		aView node: #NOM forIt: [ |locNom|
			locNom := self loc/self nom.
			aView interaction popupText: [:n | 'Operation Structuring (LOC/Operation). Indication of how well the code is distributed among operations'].
			aView shape label fillColor: (self colorForMetric: #LocNom withValue: locNom); fontColor: Color white.
			aView node: (self truncatedStringForFraction: locNom).
			aView interaction popupText: [:n | 'Number Of Methods']. 
			aView shape label fillColor: Color paleYellow.
			aView 	node: 'NOM' ].
		aView shape rectangle width: 300; height: 30; withoutBorder ; fillColor: Color paleYellow.
		aView node: #LOC forIt: [
			|cycloLoc|
			cycloLoc := self cyclo/ self loc.
			aView interaction popupText: [:n | 'Intrinsic operation complexity (CYCLO/Code Line). Characterizes how much conditional complexity we are to expect in operations'].
			aView shape label fillColor: (self colorForMetric: #CycloLoc withValue: cycloLoc); fontColor: Color white.
			aView node: (self truncatedStringForFraction:cycloLoc).
			aView interaction popupText: [:n | 'Lines Of Code']. 
			aView shape label fillColor: Color paleYellow.
			aView node: 'LOC' ].
		aView shape rectangle width: 300; height: 30 ; withoutBorder; fillColor: Color paleYellow.
		aView node: #CYCLO forIt: [
			aView shape label fillColor: Color paleYellow.
			aView interaction popupText: [:n | 'Cyclomatic Number']. 
			aView node: 'CYCLO' ].
		aView verticalLineLayout gapSize: 0; alignRight].
	aView shape rectangle withoutBorder.
	aView node: #greenAndYellowMetricValues forIt: [
		aView shape rectangle width: 50; height: 30; withoutBorder ; fillColor: Color paleGreen.
		aView node: #ANDCValue forIt: [
			aView interaction popupText: [:n | 'Average number of derived classes. First sign of how extensively abstractions are refined by means of inheritance'].
			aView shape label  fillColor: (self colorForMetric: #ANDC withValue: self andc); fontColor: Color white.
			aView node: (self truncatedStringForFraction: self andc).
			].
		aView shape rectangle width: 50; height: 30; withoutBorder ; fillColor: Color paleGreen.
		aView node: #AHHValue forIt: [
			aView interaction popupText: [:n | 'Average Hierarchy Height. tell us how deep the class hierarchies are'].
			aView shape label  fillColor: (self colorForMetric: #AHH withValue: self ahh); fontColor: Color white.
			aView node: (self truncatedStringForFraction: self ahh).
			].
		aView shape rectangle width: 50; height: 30; withoutBorder ; fillColor: Color paleYellow.
		aView node: #NOPValue forIt: [
			aView interaction popupText: [:n | 'Number Of Packages']. 
			aView shape label fillColor: Color paleYellow; textAlignment: #right.
			aView node: self nop asString.
			].
		aView shape rectangle width: 50; height: 30; withoutBorder ; fillColor: Color paleYellow.
		aView node: #NOCValue forIt: [
			aView interaction popupText: [:n | 'Number Of Classes']. 
			aView shape label fillColor: Color paleYellow.
			aView node: self noc asString.
			].
		aView shape rectangle width: 50; height: 30; withoutBorder ; fillColor: Color paleYellow.
		aView node: #NOMValue forIt: [
			aView interaction popupText: [:n | 'Number Of Methods']. 
			aView shape label fillColor: Color paleYellow.
			aView node: self nom asString.
			].
		aView shape rectangle width: 50; height: 30; withoutBorder ; fillColor: Color paleYellow.
		aView node: #LOCValue forIt: [
			aView interaction popupText: [:n | 'Lines Of Code']. 
			aView shape label fillColor: Color paleYellow.
			aView node: self loc asString.
			].
		aView shape rectangle width: 50; height: 30; withoutBorder ; fillColor: Color paleYellow.
		aView node: #CYCLOValue forIt: [
			aView interaction popupText: [:n | 'Cyclomatic number']. 
			aView shape label fillColor: Color paleYellow.
			aView node: self cyclo asString.
			].
		aView verticalLineLayout gapSize: 0.
		].
	aView shape rectangle withoutBorder.
	aView node: #purpleMetricValues forIt: [
		aView shape rectangle width: 50; height: 30; withoutBorder ; fillColor: Color lightMagenta.
		aView node: #NOM forIt: [
			aView shape label fillColor: Color lightMagenta.
			aView node: ''.
			].
			
		aView shape rectangle width: 50; height: 30; withoutBorder ; fillColor: Color lightMagenta.
		aView node: #CALLS forIt: [
			aView interaction popupText: [:n | 'Number Of Invocations']. 
			aView shape label fillColor: Color lightMagenta.
			aView node: self calls asString.
			].
		
		aView shape rectangle width: 50; height: 30; withoutBorder ; fillColor: Color lightMagenta.
		aView node: #FANOUT forIt: [
			aView interaction popupText: [:n | 'Number Of Called Classes']. 
			aView shape label fillColor: Color lightMagenta.
			aView node: self fanout asString.
			].
			
		
		aView verticalLineLayout gapSize: 0.
		].
	aView shape rectangle withoutBorder.
	aView node: #purple forIt: [
		aView shape rectangle width: 150; height: 30; withoutBorder ; fillColor: Color lightMagenta.
		aView node: #NOM forIt: [
			|callsNom|
			callsNom := self calls/ self nom.
			aView shape label width: 90; fillColor: Color lightMagenta.
			aView interaction popupText: [:n | 'Number Of Methods']. 
			aView node: 'NOM'.
			aView interaction popupText: [:n | ' Coupling intensity (CALLS/Operation). Tell us how many other operations are called on average from each operation'].
			aView shape label width: 35;fillColor: (self colorForMetric: #CallsNom withValue: callsNom); fontColor: Color white.
			aView node: (self truncatedStringForFraction: callsNom).
			aView horizontalLineLayout alignRight.
			].
		aView shape rectangle width: 200; height: 30; withoutBorder ; fillColor: Color lightMagenta.
		aView node: #CALLS forIt: [
			|fanoutCalls|
			fanoutCalls := self fanout / self calls.
			aView shape label width: 75; fillColor: Color lightMagenta.
			aView node: ''.
			aView interaction popupText: [:n | 'Number Of Invocations']. 
			aView shape label width: 55; fillColor: Color lightMagenta.
			aView node: 'CALLS'.
			aView interaction popupText: [:n | 'Coupling dispersion (FANOUT/Operation Call). Indicator of how much the coupling involves many classes '].
			aView shape label width: 35; fillColor:  (self colorForMetric: #FanoutCalls withValue: fanoutCalls); fontColor: Color white.
			aView node: (self truncatedStringForFraction: fanoutCalls).
			].
		aView shape rectangle width: 200; height: 30; withoutBorder ; fillColor: Color lightMagenta.
		aView node: #FANOUT forIt: [
			aView shape label width: 125; fillColor: Color lightMagenta..
			aView node: ''.
			aView interaction popupText: [:n | 'Number Of Called Classes']. 
			aView shape label width: 35; fillColor: Color lightMagenta..
			aView node: 'FANOUT'.
			].
		aView verticalLineLayout gapSize: 0.
		].
	aView horizontalLineLayout gapSize: 0; alignBottom.! !

!OverviewPyramid methodsFor: 'accessing - treeshold' stamp: 'cyrille.delaunay 8/9/2010 13:40'!
treesholdsToUse

	^ treesholdsToUse.! !

!OverviewPyramid methodsFor: 'accessing - treeshold' stamp: 'cyrille.delaunay 8/9/2010 13:43'!
treesholdsToUse: aDictionary

	treesholdsToUse := aDictionary. ! !

!OverviewPyramid methodsFor: 'private' stamp: 'cyrilledelaunay 3/3/2011 16:06'!
truncatedFloatForFraction: aFraction
	^ (((aFraction * 100) truncated) / 100 ) asFloat ! !

!OverviewPyramid methodsFor: 'private' stamp: 'cyrilledelaunay 3/3/2011 16:06'!
truncatedStringForFraction: aFraction
	^ (self truncatedFloatForFraction: aFraction) asString! !

!OverviewPyramid methodsFor: 'accessing - treeshold' stamp: 'cyrille.delaunay 8/9/2010 13:43'!
useCPPTreesholds

	self treesholdsToUse: CPPTreesholds. ! !

!OverviewPyramid methodsFor: 'accessing - treeshold' stamp: 'cyrille.delaunay 8/9/2010 13:43'!
useJavaTreesholds

	self treesholdsToUse:  JavaTreesholds. ! !

!HismoClassHistory methodsFor: '*moose-mondrianpaintings' stamp: 'JurajKubelka 4/1/2013 15:42'!
viewEvolution
	<menuItem: 'Evolution' category: 'Visualize'> 
	| view |
	view := ROMondrianViewBuilder new.
	self viewEvolutionOn: view.
	^ view open! !

!HismoClassHistory methodsFor: '*moose-mondrianpaintings' stamp: 'jannik.laval 9/2/2009 16:35'!
viewEvolutionOn: view
	view shape rectangle 
		width: #numberOfAttributes; 
		height: #numberOfMethods;
		linearFillColor: #numberOfLinesOfCode within: (self versions collect: #versionEntity).
	view nodes: (self versions collect: #versionEntity).! !
OverviewPyramid initialize!
